diff --git a/configure.ac b/configure.ac
index 5badc7f..e604b2d 100644
--- a/configure.ac
+++ b/configure.ac
@@ -932,10 +932,6 @@ case "${target}" in
     ;;
   *-*-rtems*)
     noconfigdirs="$noconfigdirs target-libgloss"
-    # this is not caught below because this stanza matches earlier
-    case $target in
-      or1k*-*-*) noconfigdirs="$noconfigdirs gdb" ;;
-    esac
     ;;
     # The tpf target doesn't support gdb yet.
   *-*-tpf*)
@@ -1137,9 +1133,6 @@ case "${target}" in
   nds32*-*-*)
     noconfigdirs="$noconfigdirs gdb"
     ;;
-  or1k*-*-*)
-    noconfigdirs="$noconfigdirs gdb"
-    ;;
   sh-*-* | sh64-*-*)
     case "${target}" in
       sh*-*-elf)
diff --git a/gdb/configure.tgt b/gdb/configure.tgt
index 7fdd34e..eba1043 100644
--- a/gdb/configure.tgt
+++ b/gdb/configure.tgt
@@ -407,6 +407,32 @@ nios2*-*-*)
 	gdb_target_obs="nios2-tdep.o"
 	;;
 
+or1k-*-linux*)
+	# Target: OpenCores OpenRISC 1000 32-bit implementation for Linux
+	gdb_target_obs="or1k-tdep.o corelow.o"
+	gdb_sim=../sim/or1k/libsim.a
+	build_gdbserver=yes
+	;;
+
+or1k-*-*)
+	# Target: OpenCores OpenRISC 1000 32-bit implementation bare metal
+	gdb_target_obs="or1k-tdep.o"
+    gdb_sim=../sim/or1k/libsim.a
+	;;
+
+or1knd-*-linux*)
+	# Target: OpenCores OpenRISC 1000 32-bit implementation for Linux, without delay slot
+	gdb_target_obs="or1k-tdep.o corelow.o"
+    gdb_sim=../sim/or1k/libsim.a
+	build_gdbserver=yes
+	;;
+
+or1knd-*-*)
+	# Target: OpenCores OpenRISC 1000 32-bit implementation bare metal, without delay slot
+	gdb_target_obs="or1k-tdep.o"
+	gdb_sim=../sim/or1k/libsim.a
+	;;
+
 powerpc*-*-freebsd*)
 	# Target: FreeBSD/powerpc
 	gdb_target_obs="rs6000-tdep.o ppc-sysv-tdep.o ppc64-tdep.o \
diff --git a/gdb/doc/gdb.texinfo b/gdb/doc/gdb.texinfo
index f413e23..41d2854 100644
--- a/gdb/doc/gdb.texinfo
+++ b/gdb/doc/gdb.texinfo
@@ -541,6 +541,10 @@ Steve Tjiang, John Newlin, and Scott Foehner.
 Michael Eager and staff of Xilinx, Inc., contributed support for the
 Xilinx MicroBlaze architecture.
 
+The original port to the OpenRISC 1000 is believed to be due to
+Alessandro Forin and Per Bothner. More recent ports have been the work
+of Jeremy Bennett.
+
 @node Sample Session
 @chapter A Sample @value{GDBN} Session
 
@@ -20823,6 +20827,7 @@ acceptable commands.
 * M68K::                        Motorola M68K
 * MicroBlaze::			Xilinx MicroBlaze
 * MIPS Embedded::               MIPS Embedded
+* OpenRISC 1000::               OpenRISC 1000 (or1k)
 * PowerPC Embedded::            PowerPC Embedded
 * PA::                          HP PA Embedded
 * Sparclet::                    Tsqware Sparclet
@@ -21296,6 +21301,104 @@ This command allows sending an arbitrary @var{command} string to the
 monitor.  The monitor must be in debug mode for this to work.
 @end table
 
+@node OpenRISC 1000
+@subsection OpenRISC 1000
+@cindex OpenRISC 1000
+
+Previous versions of @value{GDBN} supported remote connection via a
+proprietary JTAG protocol using the @samp{target jtag} command. Support
+for this has now been dropped.
+
+
+@table @code
+
+@kindex target remote
+@item target remote
+
+This is now the only way to connect to a remote OpenRISC 1000
+target.  This is supported by @dfn{Or1ksim}, the OpenRISC 1000
+architectural simulator, Verilator and Icarus Verilog
+simulations.  @dfn{Remote serial protocol} servers are also available to
+drive various hardware implementations via JTAG.
+Connects to remote JTAG server.
+
+Example: @code{target remote :51000}
+
+@kindex target sim
+@item target sim
+
+@dfn{Or1ksim}, the OpenRISC 1000 architectural simulator is now
+incorporated within @value{GDBN} as a simulator target.  It is started
+in quiet mode with 8M of memory starting at address 0.  It is possible
+to pass arguments to extend this configuration using the @samp{-f}
+option to @samp{target sim}.  However for more complex use, the user is
+advised to run @dfn{Or1ksim} separately, with its own configuration
+file, and connect using @samp{target remote}
+
+Example: @code{target sim}
+
+@kindex info spr
+@item info or1k spr
+Displays groups.
+
+@item info spr @var{group}
+@itemx info spr @var{groupno}
+Displays register names in selected group.
+
+@item info spr @var{group} @var{register}
+@itemx info spr @var{register}
+@itemx info spr @var{groupno} @var{registerno}
+@itemx info spr @var{registerno}
+Shows information about specified spr register.
+
+Example: @code{info spr DRR}
+
+@code{DEBUG.DRR = SPR6_21 = 0 (0x0)}
+
+@kindex spr
+@item spr @var{group} @var{register} @var{value}
+@itemx spr @var{register @var{value}}
+@itemx spr @var{groupno} @var{registerno @var{value}}
+@itemx spr @var{registerno @var{value}}
+Writes @var{value} to specified spr register.
+
+Example: spr PICMR 0x24
+@end table
+
+The use of @samp{info} and @samp{spr} commands is anachronistic.  At
+some time in the future they will be replaced by @samp{info register @var{spr | group name}}
+and @samp{set $spr=@var{value}}.
+
+There are some known problems with the current implementation
+@cindex OpenRISC 1000 known problems
+
+@enumerate
+
+@item
+@cindex OpenRISC 1000 known problems, hardware breakpoints and watchpoints
+Some OpenRISC 1000 targets support hardware breakpoints and watchpoints.
+Consult the target documentation for details.  @value{GDBN} is not
+perfect in handling of watchpoints.  It is possible to allocate hardware
+watchpoints and not discover until running that sufficient watchpoints
+are not available.  It is also possible that GDB will report watchpoints
+being hit spuriously.  This can be down to the assembly code having
+additional memory accesses that are not obviously reflected in the
+source code.
+
+@item
+@cindex OpenRISC 1000 known problems, architectural compatability
+The OpenRISC 1000 architecture has evolved since the first port of @value{GDBN}. In particular the structure of the Unit Present register has
+changed and the CPU Configuration register has been added.  The port of
+@value{GDBN} version @value{GDBVN} uses the @emph{current}
+specification of the OpenRISC 1000.
+
+@end enumerate
+
+@cindex Bugs, reporting
+@cindex Reporting bugs
+Reports of bugs are much welcomed. Please report problems through the
+OpenRISC tracker at @uref{http://opencores.org/openrisc,downloads}.
+
 @node PowerPC Embedded
 @subsection PowerPC Embedded
 
diff --git a/gdb/or1k-tdep.h b/gdb/or1k-tdep.h
new file mode 100644
index 0000000..f0afc8f
--- /dev/null
+++ b/gdb/or1k-tdep.h
@@ -0,0 +1,434 @@
+/* Definitions to target GDB to OpenRISC 1000 32-bit targets.
+
+   Copyright 2001 Free Software Foundation, Inc.
+   Copyright (C) 2008, 2010 Embecosm Limited
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com>
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by the Free
+   Software Foundation; either version 3 of the License, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful, but WITHOUT
+   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+   more details.
+
+   You should have received a copy of the GNU General Public License along
+   with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+
+#ifndef OR1K_TDEP__H
+#define OR1K_TDEP__H
+
+#ifndef TARGET_OR1K
+#define TARGET_OR1K
+#endif
+
+/*-----------------------------------------------------------------------------
+   This version for the OpenRISC 1000 architecture is a rewrite by Jeremy
+   Bennett of the old GDB 5.3 interface to make use of gdbarch for GDB 6.8.
+
+   The code tries to follow the GDB coding style. All OR1K specific globals
+   should have names beginning ork1_ or OR1K_.
+
+   Commenting is Doxygen compatible.
+
+   Much has been stripped out. See the files or1k-tdep.c, remote-or1k.c and
+   or1k-jtag.c for details of what has changed.
+   --------------------------------------------------------------------------*/
+
+
+/*! Byte array for the TRAP instruction used for breakpoints */
+#define OR1K_BRK_INSTR_STRUCT  {0x21, 0x00, 0x00, 0x01}
+/*! Numeric instruction used for a breakpoint */
+#define OR1K_BRK_INSTR 0x21000001
+
+/*! Numeric instruction used for a l.nop NOP_EXIT */
+#define  OR1K_NOP_EXIT 0x15000001
+
+/* Special purpose groups */
+
+#define OR1K_SPG_SIZE_BITS  11
+#define OR1K_SPG_SIZE       (1 << OR1K_SPG_SIZE_BITS)
+
+#define OR1K_SPG_SYS      0
+#define OR1K_SPG_DMMU     1
+#define OR1K_SPG_IMMU     2
+#define OR1K_SPG_DC       3
+#define OR1K_SPG_IC       4
+#define OR1K_SPG_MAC      5
+#define OR1K_SPG_DEBUG    6
+#define OR1K_SPG_PC       7
+#define OR1K_SPG_PM       8
+#define OR1K_SPG_PIC      9
+#define OR1K_SPG_TT      10
+#define OR1K_SPG_FPU     11
+
+#define OR1K_NUM_SPGS   (OR1K_SPG_FPU + 1)
+
+/* Special register group offsets */
+
+#define OR1K_SPG_SYS_VR          0
+#define OR1K_SPG_SYS_UPR         1
+#define OR1K_SPG_SYS_CPUCFGR     2
+#define OR1K_SPG_SYS_DMMUCFGR    3
+#define OR1K_SPG_SYS_IMMUCFGR    4
+#define OR1K_SPG_SYS_DCCFGR      5
+#define OR1K_SPG_SYS_ICCFGR      6
+#define OR1K_SPG_SYS_DCFGR       7
+#define OR1K_SPG_SYS_PCCFGR      8
+#define OR1K_SPG_SYS_NPC        16
+#define OR1K_SPG_SYS_SR         17
+#define OR1K_SPG_SYS_PPC        18
+#define OR1K_SPG_SYS_FPCSR      20
+#define OR1K_SPG_SYS_EPCR       32
+#define OR1K_SPG_SYS_EPCR_END  (OR1K_SPG_SYS_EPCR + 15)
+#define OR1K_SPG_SYS_EEAR       48
+#define OR1K_SPG_SYS_EEAR_END  (OR1K_SPG_SYS_EEAR + 15)
+#define OR1K_SPG_SYS_ESR        64
+#define OR1K_SPG_SYS_ESR_END   (OR1K_SPG_SYS_ESR + 15)
+#define OR1K_SPG_SYS_GPR      1024
+#define OR1K_SPG_SYS_GPR_END   (OR1K_SPG_SYS_GPR + OR1K_MAX_GPR_REGS)
+#define OR1K_SPG_SYS_LAST       OR1K_SPG_SYS_GPR_END
+
+#define OR1K_SPG_DMMU_DMMUCR           0
+#define OR1K_SPG_DMMU_DMMUPR           1
+#define OR1K_SPG_DMMU_DTLBEIR          2
+#define OR1K_SPG_DMMU_DATBMR           4
+#define OR1K_SPG_DMMU_DATBMR_END   (OR1K_SPG_DMMU_DATBMR + 3)
+#define OR1K_SPG_DMMU_DATBTR           8
+#define OR1K_SPG_DMMU_DATBTR_END   (OR1K_SPG_DMMU_DATBTR + 3)
+#define OR1K_SPG_DMMU_DTLBW0MR       512
+#define OR1K_SPG_DMMU_DTLBW0MR_END (OR1K_SPG_DMMU_DTLBW0MR + 127)
+#define OR1K_SPG_DMMU_DTLBW0TR       640
+#define OR1K_SPG_DMMU_DTLBW0TR_END (OR1K_SPG_DMMU_DTLBW0TR + 127)
+#define OR1K_SPG_DMMU_DTLBW1MR       768
+#define OR1K_SPG_DMMU_DTLBW1MR_END (OR1K_SPG_DMMU_DTLBW1MR + 127)
+#define OR1K_SPG_DMMU_DTLBW1TR       896
+#define OR1K_SPG_DMMU_DTLBW1TR_END (OR1K_SPG_DMMU_DTLBW1TR + 127)
+#define OR1K_SPG_DMMU_DTLBW2MR      1024
+#define OR1K_SPG_DMMU_DTLBW2MR_END (OR1K_SPG_DMMU_DTLBW2MR + 127)
+#define OR1K_SPG_DMMU_DTLBW2TR      1152
+#define OR1K_SPG_DMMU_DTLBW2TR_END (OR1K_SPG_DMMU_DTLBW2TR + 127)
+#define OR1K_SPG_DMMU_DTLBW3MR      1280
+#define OR1K_SPG_DMMU_DTLBW3MR_END (OR1K_SPG_DMMU_DTLBW3MR + 127)
+#define OR1K_SPG_DMMU_DTLBW3TR      1408
+#define OR1K_SPG_DMMU_DTLBW3TR_END (OR1K_SPG_DMMU_DTLBW3TR + 127)
+#define OR1K_SPG_DMMU_LAST          OR1K_SPG_DMMU_DTLBW3TR_END
+
+#define OR1K_SPG_IMMU_IMMUCR           0
+#define OR1K_SPG_IMMU_IMMUPR           1
+#define OR1K_SPG_IMMU_ITLBEIR          2
+#define OR1K_SPG_IMMU_IATBMR           4
+#define OR1K_SPG_IMMU_IATBMR_END   (OR1K_SPG_IMMU_IATBMR + 3)
+#define OR1K_SPG_IMMU_IATBTR           8
+#define OR1K_SPG_IMMU_IATBTR_END   (OR1K_SPG_IMMU_IATBTR + 3)
+#define OR1K_SPG_IMMU_ITLBW0MR       512
+#define OR1K_SPG_IMMU_ITLBW0MR_END (OR1K_SPG_IMMU_ITLBW0MR + 127)
+#define OR1K_SPG_IMMU_ITLBW0TR       640
+#define OR1K_SPG_IMMU_ITLBW0TR_END (OR1K_SPG_IMMU_ITLBW0TR + 127)
+#define OR1K_SPG_IMMU_ITLBW1MR       768
+#define OR1K_SPG_IMMU_ITLBW1MR_END (OR1K_SPG_IMMU_ITLBW1MR + 127)
+#define OR1K_SPG_IMMU_ITLBW1TR       896
+#define OR1K_SPG_IMMU_ITLBW1TR_END (OR1K_SPG_IMMU_ITLBW1TR + 127)
+#define OR1K_SPG_IMMU_ITLBW2MR      1024
+#define OR1K_SPG_IMMU_ITLBW2MR_END (OR1K_SPG_IMMU_ITLBW2MR + 127)
+#define OR1K_SPG_IMMU_ITLBW2TR      1152
+#define OR1K_SPG_IMMU_ITLBW2TR_END (OR1K_SPG_IMMU_ITLBW2TR + 127)
+#define OR1K_SPG_IMMU_ITLBW3MR      1280
+#define OR1K_SPG_IMMU_ITLBW3MR_END (OR1K_SPG_IMMU_ITLBW3MR + 127)
+#define OR1K_SPG_IMMU_ITLBW3TR      1408
+#define OR1K_SPG_IMMU_ITLBW3TR_END (OR1K_SPG_IMMU_ITLBW3TR + 127)
+#define OR1K_SPG_IMMU_LAST          OR1K_SPG_IMMU_ITLBW3TR_END
+
+#define OR1K_SPG_DC_DCCR   0
+#define OR1K_SPG_DC_DCBPR  1
+#define OR1K_SPG_DC_DCBFR  2
+#define OR1K_SPG_DC_DCBIR  3
+#define OR1K_SPG_DC_DCBWR  4
+#define OR1K_SPG_DC_DCBLR  5
+#define OR1K_SPG_DC_LAST   OR1K_SPG_DC_DCBLR
+
+#define OR1K_SPG_IC_ICCR   0
+#define OR1K_SPG_IC_ICBPR  1
+#define OR1K_SPG_IC_ICBIR  2
+#define OR1K_SPG_IC_ICBLR  3
+#define OR1K_SPG_IC_LAST   OR1K_SPG_IC_ICBLR
+
+#define OR1K_SPG_MAC_MACLO  1
+#define OR1K_SPG_MAC_MACHI  2
+#define OR1K_SPG_MAC_LAST   OR1K_SPG_MAC_MACHI
+
+#define OR1K_SPG_DEBUG_DVR      0
+#define OR1K_SPG_DEBUG_DVR_END (OR1K_SPG_DEBUG_DVR + 7)
+#define OR1K_SPG_DEBUG_DCR      8
+#define OR1K_SPG_DEBUG_DCR_END (OR1K_SPG_DEBUG_DCR + 7)
+#define OR1K_SPG_DEBUG_DMR1   16
+#define OR1K_SPG_DEBUG_DMR2   17
+#define OR1K_SPG_DEBUG_DCWR0  18
+#define OR1K_SPG_DEBUG_DCWR1  19
+#define OR1K_SPG_DEBUG_DSR    20
+#define OR1K_SPG_DEBUG_DRR    21
+#define OR1K_SPG_DEBUG_LAST   OR1K_SPG_DEBUG_DRR
+
+#define OR1K_SPG_PC_PCCR       0
+#define OR1K_SPG_PC_PCCR_END  (OR1K_SPG_PC_PCCR + 7)
+#define OR1K_SPG_PC_PCMR       8
+#define OR1K_SPG_PC_PCMR_END  (OR1K_SPG_PC_PCMR + 7)
+#define OR1K_SPG_PC_LAST       OR1K_SPG_PC_PCMR_END
+
+#define OR1K_SPG_PM_PMR     0
+#define OR1K_SPG_PM_LAST    OR1K_SPG_PM_PMR
+
+#define OR1K_SPG_PIC_PICMR  0
+#define OR1K_SPG_PIC_PICSR  2
+#define OR1K_SPG_PIC_LAST   OR1K_SPG_PIC_PICSR
+
+#define OR1K_SPG_TT_TTMR    0
+#define OR1K_SPG_TT_TTCR    1
+#define OR1K_SPG_TT_LAST    OR1K_SPG_TT_TTCR
+
+#define OR1K_SPG_FPU_LAST  -1
+
+
+/* Define absolute SPR values from group and index  */
+#define OR1K_SPR(group, index) (((group) << OR1K_SPG_SIZE_BITS) + (index))
+
+/* System group registers */
+#define OR1K_VR_SPRNUM       OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_VR)
+#define OR1K_UPR_SPRNUM      OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_UPR)
+#define OR1K_CPUCFGR_SPRNUM  OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_CPUCFGR)
+#define OR1K_DCFGR_SPRNUM    OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_DCFGR)
+#define OR1K_NPC_SPRNUM      OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_NPC)
+#define OR1K_SR_SPRNUM       OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_SR)
+#define OR1K_PPC_SPRNUM      OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_PPC)
+#define OR1K_EPCR_SPRNUM     OR1K_SPR (OR1K_SPG_SYS, OR1K_SPG_SYS_EPCR)
+
+/* Debug group registers */
+#define OR1K_DVR0_SPRNUM     OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DVR)
+#define OR1K_DCR0_SPRNUM     OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DCR)
+#define OR1K_DMR1_SPRNUM     OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DMR1)
+#define OR1K_DMR2_SPRNUM     OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DMR2)
+#define OR1K_DCWR0_SPRNUM    OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DCWR0)
+#define OR1K_DCWR1_SPRNUM    OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DCWR0)
+#define OR1K_DSR_SPRNUM      OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DSR)
+#define OR1K_DRR_SPRNUM      OR1K_SPR (OR1K_SPG_DEBUG, OR1K_SPG_DEBUG_DRR)
+
+/* General Purpose Registers */
+#define OR1K_ZERO_REGNUM          0
+#define OR1K_SP_REGNUM            1
+#define OR1K_FP_REGNUM            2
+#define OR1K_FIRST_ARG_REGNUM     3
+#define OR1K_LAST_ARG_REGNUM      8
+#define OR1K_LR_REGNUM            9
+#define OR1K_FIRST_SAVED_REGNUM  10
+#define OR1K_RV_REGNUM           11
+#define OR1K_PPC_REGNUM          (OR1K_MAX_GPR_REGS + 0)
+#define OR1K_NPC_REGNUM          (OR1K_MAX_GPR_REGS + 1)
+#define OR1K_SR_REGNUM           (OR1K_MAX_GPR_REGS + 2)
+
+/* Defines for Debug Control Register bits */
+
+#define OR1K_DCR_DP        0x0000001    /* DVR/DCR Present */
+#define OR1K_DCR_CC        0x000000e    /* Compare condition */
+#define OR1K_DCR_CC_OFF            1    /* Compare condition offset */
+#define OR1K_DCR_SC        0x0000010    /* Signed compare */
+#define OR1K_DCR_CT        0x00000e0    /* Compare type */
+#define OR1K_DCR_CT_OFF            5    /* Compare type offset */
+
+/* Defines for Debug Mode Register 1 bits.  */
+#define OR1K_DMR1_CW       0x00000003   /* Mask for CW bits */
+#define OR1K_DMR1_CW_AND   0x00000001	/* Chain watchpoint 0 AND */
+#define OR1K_DMR1_CW_OR    0x00000002	/* Chain watchpoint 0 OR */
+#define OR1K_DMR1_CW_SZ             2   /* Number of bits for each WP */
+#define OR1K_DMR1_ST       0x00400000	/* Single-step trace */
+#define OR1K_DMR1_BT       0x00800000	/* Branch trace */
+
+/* Defines for Debug Mode Register 2 bits.  */
+#define OR1K_DMR2_WCE0       0x00000001	/* Watchpoint counter enable 0 */
+#define OR1K_DMR2_WCE1       0x00000002	/* Watchpoint counter enable 1 */
+#define OR1K_DMR2_AWTC_MASK  0x00000ffc	/* Assign watchpoints to ctr mask */
+#define OR1K_DMR2_WGB_MASK   0x003ff000	/* Watchpoints generaing brk mask */
+#define OR1K_DMR2_WBS_MASK   0xffc00000 /* Watchpoint brkpt status mask */
+#define OR1K_DMR2_AWTC_OFF    2		/* Assign watchpoints to ctr offset */
+#define OR1K_DMR2_WGB_OFF    12		/* Watchpoints generating brk offset */
+#define OR1K_DMR2_WBS_OFF    22		/* Watchpoint brkpt status offset */
+
+/* Defines for Debug Stop Register.  */
+#define OR1K_DSR_RSTE    0x00000001	/* Reset exception */
+#define OR1K_DSR_BUSEE   0x00000002	/* Bus error exception */
+#define OR1K_DSR_DPFE    0x00000004	/* Data page fault exception */
+#define OR1K_DSR_IPFE    0x00000008	/* Instrution page fault exception */
+#define OR1K_DSR_TTE     0x00000010	/* Tick timer exception */
+#define OR1K_DSR_AE      0x00000020	/* Alignment exception */
+#define OR1K_DSR_IIE     0x00000040	/* Illegal instruction exception */
+#define OR1K_DSR_INTE    0x00000080	/* Interrupt exception */
+#define OR1K_DSR_DME     0x00000100	/* DTLB miss exception */
+#define OR1K_DSR_IME     0x00000200	/* ITLB miss exception */
+#define OR1K_DSR_RE      0x00000400	/* Range exception */
+#define OR1K_DSR_SCE     0x00000800	/* System call exception */
+#define OR1K_DSR_FPE     0x00001000	/* Floating point exception */
+#define OR1K_DSR_TE      0x00002000	/* Trap exception */
+
+/* Defines for Debug Reason Register bits */
+#define OR1K_DRR_RSTE    0x00000001	/* Reset exception */
+#define OR1K_DRR_BUSEE   0x00000002	/* Bus error exception */
+#define OR1K_DRR_DPFE    0x00000004	/* Data page fault exception */
+#define OR1K_DRR_IPFE    0x00000008	/* Instrution page fault exception */
+#define OR1K_DRR_TTE     0x00000010	/* Tick timer exception */
+#define OR1K_DRR_AE      0x00000020	/* Alignment exception */
+#define OR1K_DRR_IIE     0x00000040	/* Illegal instruction exception */
+#define OR1K_DRR_INTE    0x00000080	/* Interrupt exception */
+#define OR1K_DRR_DME     0x00000100	/* DTLB miss exception */
+#define OR1K_DRR_IME     0x00000200	/* ITLB miss exception */
+#define OR1K_DRR_RE      0x00000400	/* Range exception */
+#define OR1K_DRR_SCE     0x00000800	/* System call exception */
+#define OR1K_DRR_FPE     0x00001000	/* Floating point exception */
+#define OR1K_DRR_TE      0x00002000	/* Trap exception */
+
+/* Bit definitions for the Unit Present Register */
+#define OR1K_SPR_UPR_UP	        0x00000001  /* UPR present */
+#define OR1K_SPR_UPR_DCP        0x00000002  /* Data cache present */
+#define OR1K_SPR_UPR_ICP        0x00000004  /* Instruction cache present */
+#define OR1K_SPR_UPR_DMP        0x00000008  /* Data MMU present */
+#define OR1K_SPR_UPR_IMP        0x00000010  /* Instruction MMU present */
+#define OR1K_SPR_UPR_MP         0x00000020  /* MAC present */
+#define OR1K_SPR_UPR_DUP        0x00000040  /* Debug unit present */
+#define OR1K_SPR_UPR_PCUP       0x00000080  /* Perf counters unit present */
+#define OR1K_SPR_UPR_PMP        0x00000100  /* Power management present */
+#define OR1K_SPR_UPR_PICP       0x00000200  /* PIC present */
+#define OR1K_SPR_UPR_TTP        0x00000400  /* Tick timer present */
+
+/* Bit definitions for the CPU Configuration Register */
+#define OR1K_SPR_CPUCFGR_NSGF   0x0000000f  /* Number of shadow GPR files */
+#define OR1K_SPR_CPUCFGR_CGF    0x00000010  /* Custom GPR file */
+#define OR1K_SPR_CPUCFGR_OB32S  0x00000020  /* ORBIS32 supported */
+#define OR1K_SPR_CPUCFGR_OB64S  0x00000040  /* ORBIS64 supported */
+#define OR1K_SPR_CPUCFGR_OF32S  0x00000080  /* ORFPX32 supported */
+#define OR1K_SPR_CPUCFGR_OF64S  0x00000100  /* ORFPX64 supported */
+#define OR1K_SPR_CPUCFGR_OV64S  0x00000400  /* ORVDX64 supported */
+
+/* Bit definitions for the Debug configuration register */
+#define OR1K_SPR_DCFGR_NDP      0x00000007  /* Number of matchpoints */
+#define OR1K_SPR_DCFGR_WPCI     0x00000008  /* Watchpoint ctrs implemented */
+
+/* Properties of the architecture. GDB mapping of registers is all the GPRs
+   and SPRs followed by the PPC, NPC and SR at the end. Red zone is the area
+   past the end of the stack reserved for exception handlers etc. */
+#define OR1K_MAX_GPR_REGS            32
+#define OR1K_MAX_SPR_REGS           (32 * 2048)
+#define OR1K_NUM_PSEUDO_REGS         0
+#define OR1K_NUM_REGS_CACHED        (OR1K_MAX_GPR_REGS + 3)
+#define OR1K_NUM_REGS               (OR1K_NUM_REGS_CACHED + OR1K_MAX_SPR_REGS)
+#define OR1K_TOTAL_NUM_REGS         (OR1K_NUM_REGS + OR1K_NUM_PSEUDO_REGS)
+#define OR1K_MAX_MATCHPOINTS         8
+#define OR1K_MAX_HW_WATCHES          OR1K_MAX_MATCHPOINTS
+#define OR1K_STACK_ALIGN             4
+#define OR1K_INSTLEN                 4
+#define OR1K_INSTBITLEN             (OR1K_INSTLEN * 8)
+#define OR1K_NUM_TAP_RECORDS         8
+#define OR1K_FRAME_RED_ZONE_SIZE     2536
+
+/* OR1K exception vectors */
+
+#define OR1K_RESET_VECTOR   0x100
+#define OR1K_BUSERR_VECTOR  0x200
+#define OR1K_DPF_VECTOR     0x300
+#define OR1K_IPF_VECTOR     0x400
+#define OR1K_TT_VECTOR      0x500
+#define OR1K_ALIGN_VECTOR   0x600
+#define OR1K_ILL_VECTOR     0x700
+#define OR1K_EXT_VECTOR     0x800
+#define OR1K_DTLB_VECTOR    0x900
+#define OR1K_ITLB_VECTOR    0xa00
+#define OR1K_RANGE_VECTOR   0xb00
+#define OR1K_SYS_VECTOR     0xc00
+#define OR1K_FP_VECTOR      0xd00
+#define OR1K_TRAP_VECTOR    0xe00
+
+/* Constants and macros to break out instruction fields. I'd expect these in
+   the assembler header, but they aren't there (for now). */
+
+#define OR1K_SEXT16(v) (((v) & 0x00008000) ? ((v) - 0x00010000) : (v))
+#define OR1K_SEXT26(v) (((v) & 0x02000000) ? ((v) - 0x04000000) : (v))
+
+#define OR1K_OPCODE1(i)  (((i) & 0xfc000000) >> 26)
+#define OR1K_OPCODE2(i) ((((i) & 0xfc000000) >> 20) | \
+			 (((i) & 0x00000300) >>  6) | \
+			  ((i) & 0x0000000f))
+#define OR1K_OPCODE3(i) ((((i) & 0xfc000000) >> 24) | \
+			 (((i) & 0x000000c0) >> 6))
+#define OR1K_OPCODE4(i) ((((i) & 0xfc000000) >> 18) | \
+			 (((i) & 0x000003c0) >>  2) | \
+			  ((i) & 0x0000000f))
+#define OR1K_OPCODE5(i)  (((i) & 0xffff0000) >> 16)
+#define OR1K_OPCODE6(i)  (((i) & 0xff000000) >> 24)
+#define OR1K_OPCODE7(i)  (((i) & 0xfc000000) >> 21)
+#define OR1K_D_REG(i)    (((i) & 0x03e00000) >> 21)
+#define OR1K_A_REG(i)    (((i) & 0x001f0000) >> 16)
+#define OR1K_B_REG(i)    (((i) & 0x0000f800) >> 11)
+#define OR1K_IMM(i)      (OR1K_SEXT16((i) & 0x0000ffff))
+#define OR1K_IMM2(i)     (OR1K_SEXT16((((i) & 0x03e00000) >> 10) |	\
+				       ((i) & 0x000003ff)))
+#define OR1K_OFFSET(i)    (OR1K_SEXT26((i) & 0x03ffffff) ))
+#define OR1K_SHIFT(i)     ((i) & 0x0000003f)
+
+/* The instruction opcodes */
+
+#define OR1K_OP_ADD     0xe00	/* Type 2 */
+#define OR1K_OP_ADDC    0xe01	/* Type 2 */
+#define OR1K_OP_ADDI     0x27	/* Type 1 */
+#define OR1K_OP_AND     0xe03	/* Type 2 */
+#define OR1K_OP_ANDI     0x29	/* Type 1 */
+#define OR1K_OP_BF       0x04	/* Type 1 */
+#define OR1K_OP_BNF      0x03	/* Type 1 */
+#define OR1K_OP_TRAP   0x2100	/* Type 5 */
+#define OR1K_OP_J        0x00	/* Type 1 */
+#define OR1K_OP_JAL      0x01	/* Type 1 */
+#define OR1K_OP_JALR     0x12	/* Type 1 */
+#define OR1K_OP_JR       0x11	/* Type 1 */
+#define OR1K_OP_LBS      0x24   /* Type 1 */
+#define OR1K_OP_LBZ      0x23   /* Type 1 */
+#define OR1K_OP_LHS      0x26   /* Type 1 */
+#define OR1K_OP_LHZ      0x25   /* Type 1 */
+#define OR1K_OP_LWS      0x22   /* Type 1 */
+#define OR1K_OP_LWZ      0x21   /* Type 1 */
+#define OR1K_OP_MFSPR    0x07   /* Type 1 */
+#define OR1K_OP_MOVHI    0x06   /* Type 1 */
+#define OR1K_OP_MTSPR    0x10   /* Type 1 */
+#define OR1K_OP_MUL     0xe36   /* Type 2 */
+#define OR1K_OP_MULI     0x2c   /* Type 1 */
+#define OR1K_OP_MULU    0xe3b   /* Type 2 */
+#define OR1K_OP_NOP      0x15   /* Type 6 */
+#define OR1K_OP_OR      0xe04	/* Type 2 */
+#define OR1K_OP_ORI      0x2a   /* Type 1 */
+#define OR1K_OP_RFE      0x09   /* Type 1 */
+#define OR1K_OP_RORI     0xe3   /* Type 3 */
+#define OR1K_OP_SB       0x36   /* Type 1 */
+#define OR1K_OP_SFEQ    0x720   /* Type 7 */
+#define OR1K_OP_SFGES   0x72b   /* Type 7 */
+#define OR1K_OP_SFGEU   0x723   /* Type 7 */
+#define OR1K_OP_SFGTS   0x72a   /* Type 7 */
+#define OR1K_OP_SFGTU   0x722   /* Type 7 */
+#define OR1K_OP_SFLES   0x72d   /* Type 7 */
+#define OR1K_OP_SFLEU   0x725   /* Type 7 */
+#define OR1K_OP_SFLTS   0x72c   /* Type 7 */
+#define OR1K_OP_SFLTU   0x724   /* Type 7 */
+#define OR1K_OP_SFNE    0x721   /* Type 7 */
+#define OR1K_OP_SLL    0x3808   /* Type 4 */
+#define OR1K_OP_SLLI     0xe0   /* Type 3 */
+#define OR1K_OP_SRA    0x3828   /* Type 4 */
+#define OR1K_OP_SRAI     0xe2   /* Type 3 */
+#define OR1K_OP_SRL    0x3818   /* Type 4 */
+#define OR1K_OP_SRLI     0xe1   /* Type 3 */
+#define OR1K_OP_SUB     0xe02   /* Type 2 */
+#define OR1K_OP_SW       0x35   /* Type 1 */
+#define OR1K_OP_SYS    0x2000   /* Type 5 */
+#define OR1K_OP_XOR     0xe05   /* Type 2 */
+#define OR1K_OP_XORI     0x2b   /* Type 1 */
+
+#endif /* OR1K_TDEP__H */
diff --git a/gdb/target-descriptions.c b/gdb/target-descriptions.c
index 885d461..5210298 100644
--- a/gdb/target-descriptions.c
+++ b/gdb/target-descriptions.c
@@ -859,6 +859,40 @@ tdesc_numbered_register (const struct tdesc_feature *feature,
   return 1;
 }
 
+/* Search FEATURE for a register REGNO and return its name. */
+char *
+tdesc_find_register_name (const struct tdesc_feature *feature,
+			   int regno)
+{
+  int ixr;
+  struct tdesc_reg *reg;
+
+  for (ixr = 0;
+       VEC_iterate (tdesc_reg_p, feature->registers, ixr, reg);
+       ixr++)
+    if (ixr == regno)
+      return reg->name;
+
+  return NULL;
+}
+
+/* Search FEATURE for a register REGNO and return its group name. */
+char *
+tdesc_find_register_group_name (const struct tdesc_feature *feature,
+			   int regno)
+{
+  int ixr;
+  struct tdesc_reg *reg;
+
+  for (ixr = 0;
+       VEC_iterate (tdesc_reg_p, feature->registers, ixr, reg);
+       ixr++)
+    if (ixr == regno)
+      return reg->group;
+
+  return NULL;
+}
+
 /* Search FEATURE for a register named NAME, but do not assign a fixed
    register number to it.  */
 
@@ -1041,12 +1075,8 @@ tdesc_remote_register_number (struct gdbarch *gdbarch, int regno)
    return -1 if it does not know; the caller should handle registers
    with no specified group.
 
-   Arbitrary strings (other than "general", "float", and "vector")
-   from the description are not used; they cause the register to be
-   displayed in "info all-registers" but excluded from "info
-   registers" et al.  The names of containing features are also not
-   used.  This might be extended to display registers in some more
-   useful groupings.
+   The names of containing features are also not used.  This might be
+   extended to display registers in some more useful groupings.
 
    The save-restore flag is also implemented here.  */
 
@@ -1075,6 +1105,10 @@ tdesc_register_in_reggroup_p (struct gdbarch *gdbarch, int regno,
 
       if (reggroup == general_reggroup)
 	return general_p;
+
+      if (strcmp (reg->group, reggroup_name (reggroup)) == 0)
+	return 1;
+
     }
 
   if (reg != NULL
diff --git a/gdb/target-descriptions.h b/gdb/target-descriptions.h
index 285debe..32cf326 100644
--- a/gdb/target-descriptions.h
+++ b/gdb/target-descriptions.h
@@ -111,6 +111,18 @@ struct tdesc_arch_data *tdesc_data_alloc (void);
 
 void tdesc_data_cleanup (void *data_untyped);
 
+/* Search FEATURE for a register REGNO and return its name. */
+
+char *tdesc_find_register_name (const struct tdesc_feature *feature,
+				int regno);
+
+
+/* Search FEATURE for a register REGNO and return its group name. */
+
+char *tdesc_find_register_group_name (const struct tdesc_feature *feature,
+				      int regno);
+
+
 /* Search FEATURE for a register named NAME.  Record REGNO and the
    register in DATA; when tdesc_use_registers is called, REGNO will be
    assigned to the register.  1 is returned if the register was found,
